﻿local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 38706 $"):match("%d+"))

if MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

ThreatLib_funcs[#ThreatLib_funcs+1] = function()

local ThreatLib = _G.ThreatLib

local BB = AceLibrary("Babble-Boss-2.2")

-- You need to register the module with the localized mob name, as this is used to 
local c = BB["Morogrim Tidewalker"]

local Morogrim = ThreatLib:GetModule("NPCCore"):NewModule(c)

local murlocStrings = {
	["enUS"] = "By the tides!",	
	["deDE"] = nil,
	["frFR"] = nil,
	["koKR"] = nil,
	["zhTW"] = nil	
}

local murlocNames = {
	["enUS"] = "Tidewalker Lurker",
	["deDE"] = nil,
	["frFR"] = nil,
	["koKR"] = nil,
	["zhTW"] = nil
}

local murlocPhase = murlocStrings[_G.GetLocale()]
local murlocName = murlocNames[_G.GetLocale()]

function Morogrim:Init()
	self:RegisterCombatant(BB["Morogrim Tidewalker"], true)
	
	if murlocName then
		self:RegisterCombatant(murlocName, self.murlocDeath)
	end
	
	if murlocPhase then
		self:RegisterChatEvent("yell", BB["Morogrim Tidewalker"], murlocPhase, self.phaseTransition)
	end
end

function Morogrim:StartFight()
	-- SetNumberOfMobs is used as a divisor for global threat. Be sure to set it correctly, and to account for mob deaths during the fight
	-- If you are unsure of the participants, or you want to just be safe, leave this at 1
	self:SetNumberOfMobs(1)
end

function Morogrim:murlocDeath()
	self:SetNumberOfMobs(self:GetNumberOfMobs() - 1)
end

function Morogrim:phaseTransition()
	if murlocName then
		self:SetNumberOfMobs(self:GetNumberOfMobs() + 12)	-- Morogrim + 12 murlocs (two packs of six)
		self:WipeRaidThreatOnMob(murlocName)
	end
end

table.insert(ThreatLib.UpvalueFixers, function(lib)
	ThreatLib = lib
	Morogrim = ThreatLib:GetModule("NPCCore"):GetModule(c)
end)

end
